package com.teletip.wado.servlet;

import java.io.IOException;
import java.io.OutputStream;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

import com.teletip.wado.controller.WADOCtrl;
import com.teletip.wado.response.WADOResponseObject;

/**
 * WADOServlet WADO istemlerinin karsilandigi ve ilgili parametrelerin WADOInfo sinifina iletildii servlet sinifidir. 
 * @author	Ayhan Ozan Yilmaz
 * @since	01.01.2017
 */
public class WADOServlet extends HttpServlet {

	private static final long serialVersionUID = 5769546040690950382L;
	
	private static Logger log = Logger.getLogger( WADOServlet.class.getName() );
    
    /**
     * @see HttpServlet#HttpServlet()
     */
    public WADOServlet() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doPost(request, response);
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// set character encoding
		request.setCharacterEncoding("UTF-8");
		response.setCharacterEncoding("UTF-8");

		/*
	    ResourceBundle bundle = ResourceBundle.getBundle(
				MEDConstants.RESOURCE_MESSAGES, new Locale("tr"));
	    CachedUserData cachedUserData = SessionUtil.checkSession(request,response, bundle);
                if(cachedUserData == null) return;

		 */
		WADOCtrl wadoCtrl = new WADOCtrl("MASTER_DBCP");
		// set request variables
		wadoCtrl.getWadoInfo().setOperation(request.getParameter(WADOCtrl.PARAM_OPERATION));
		wadoCtrl.getWadoInfo().setStudyId(request.getParameter(WADOCtrl.PARAM_STUDY_ID));
		wadoCtrl.getWadoInfo().setStudyXml(request.getParameter(WADOCtrl.PARAM_STUDY_XML));
		wadoCtrl.getWadoInfo().setDicomInstanceItemXml(request.getParameter(WADOCtrl.PARAM_DICOM_INSTANCE_ITEM_XML));
		wadoCtrl.getWadoInfo().setDicomInstanceId(request.getParameter(WADOCtrl.PARAM_DICOM_INSTANCE_ID));
		wadoCtrl.getWadoInfo().setRequestType(request.getParameter(WADOCtrl.PARAM_REQUEST_TYPE));
		wadoCtrl.getWadoInfo().setStudyUID(request.getParameter(WADOCtrl.PARAM_STUDY_UID));
		wadoCtrl.getWadoInfo().setSeriesUID(request.getParameter(WADOCtrl.PARAM_SERIES_UID));
		wadoCtrl.getWadoInfo().setObjectUID(request.getParameter(WADOCtrl.PARAM_OBJECT_UID));
		wadoCtrl.getWadoInfo().setContentType(request.getParameter(WADOCtrl.PARAM_CONTENT_TYPE));
		wadoCtrl.getWadoInfo().setCharset(request.getParameter(WADOCtrl.PARAM_CHARSET));
		wadoCtrl.getWadoInfo().setAnonymize(request.getParameter(WADOCtrl.PARAM_ANONYMIZE));
		wadoCtrl.getWadoInfo().setAnnotation(request.getParameter(WADOCtrl.PARAM_ANNOTATION));
		wadoCtrl.getWadoInfo().setRows(request.getParameter(WADOCtrl.PARAM_ROWS));
		wadoCtrl.getWadoInfo().setColumns(request.getParameter(WADOCtrl.PARAM_COLUMNS));
		wadoCtrl.getWadoInfo().setRegion(request.getParameter(WADOCtrl.PARAM_REGION));
		wadoCtrl.getWadoInfo().setWindowCenter(request.getParameter(WADOCtrl.PARAM_WINDOW_CENTER));
		wadoCtrl.getWadoInfo().setWindowWidth(request.getParameter(WADOCtrl.PARAM_WINDOW_WIDTH));
		wadoCtrl.getWadoInfo().setFrameNumber(request.getParameter(WADOCtrl.PARAM_FRAME_NUMBER));
		wadoCtrl.getWadoInfo().setImageQuality(request.getParameter(WADOCtrl.PARAM_IMAGE_QUALITY));
		wadoCtrl.getWadoInfo().setPresentationUID(request.getParameter(WADOCtrl.PARAM_PRESENTATION_UID));
		wadoCtrl.getWadoInfo().setPresentationSeriesUID(request.getParameter(WADOCtrl.PARAM_PRESENTATION_SERIES_UID));
		wadoCtrl.getWadoInfo().setTransferSyntax(request.getParameter(WADOCtrl.PARAM_TRANSFER_SYNTAX));
		wadoCtrl.getWadoInfo().setAuthorization(request.getHeader(WADOCtrl.PARAM_HEADER_AUTHORIZATION));
		wadoCtrl.getWadoInfo().setRedirectParam(request.getParameter(WADOCtrl.PARAM_REDIRECT));
		wadoCtrl.getWadoInfo().setUseOrig(request.getParameter(WADOCtrl.PARAM_USE_ORIG));
		wadoCtrl.getWadoInfo().setPrivateTags(request.getParameter(WADOCtrl.PARAM_PRIVATE_TAGS));
		wadoCtrl.getWadoInfo().setSimpleFrameList(request.getParameter(WADOCtrl.PARAM_SIMPLE_FRAME_LIST));
		wadoCtrl.getWadoInfo().setCalculatedFrameList(request.getParameter(WADOCtrl.PARAM_CALCULATED_FRAME_LIST));
		
		wadoCtrl.getWadoInfo().setContentTypes(wadoCtrl.getWadoInfo().getContentType());
        try {
            String reqURL = request.getRequestURL().append("?").append(
                    request.getQueryString()).toString();
            wadoCtrl.getWadoInfo().setRequestUrl(reqURL);
        } catch (Exception x) {
        	log.error("Error getting request URL.");
        }
		
		long twrsp1 = System.currentTimeMillis();
        log.info(request.getRemoteAddr() + " - URL: " + request.getRequestURI() + "?" + request.getQueryString());
        long twget1 = System.currentTimeMillis();
        // process page/data
     	wadoCtrl.processCtrl();
        long twget2 = System.currentTimeMillis();
        if (wadoCtrl.getErrorMsg() != null && !wadoCtrl.getErrorMsg().isEmpty()) {
            sendError(response, HttpServletResponse.SC_BAD_REQUEST, wadoCtrl.getErrorMsg());//required params missing or invalid!
            return;
        }
        int returnCode = wadoCtrl.getResponseObject().getReturnCode();
        if ( returnCode == HttpServletResponse.SC_OK ) {
            sendWADOFile(response, wadoCtrl.getResponseObject());
        } else if (returnCode == HttpServletResponse.SC_TEMPORARY_REDIRECT ) {
            try {
                response.sendRedirect(wadoCtrl.getResponseObject().getErrorMessage() ); //error message contains redirect host.
            } catch (IOException e) {
                sendError(response, HttpServletResponse.SC_INTERNAL_SERVER_ERROR, "Error: cant send redirect to client! Redirect to host "
                			+ wadoCtrl.getResponseObject().getErrorMessage()+" failed!" );
            }
        } else {
            sendError( response, returnCode, wadoCtrl.getResponseObject().getErrorMessage() );
        }
        long twrsp2 = System.currentTimeMillis();
        if (log.isDebugEnabled()) 
            log.debug("TimesToDeliverDICOMObject "+ wadoCtrl.getWadoInfo().getObjectUID()
            		+ ", with requesttype: "
            		+ wadoCtrl.getResponseObject().getContentType() + " to " 
            		+ request.getRemoteAddr() + " - user: " + request.getRemoteUser()
            		+ " took total [ms]: " + (twrsp2 -twrsp1) + ", FetchObject took [ms]: " + (twget2 -twget1)
            		+  ", Transmission took [ms]: " + ((twrsp2 - twrsp1) - (twget2 - twget1)));
		
/*
		if(wadoCtrl.getBaos() != null){
			ServletOutputStream outStream = response.getOutputStream();
			response.setContentType("application/pdf");
			response.setHeader("Content-Disposition", "attachment; filename=\"" + RandomGUID.getRandomGUID() + ".pdf\"");
			response.setDateHeader("Expires", 0);
			response.setContentLength(wadoCtrl.getBaos().size()); 

			wadoCtrl.getBaos().writeTo(outStream);
			outStream.flush();
			outStream.close();
			wadoCtrl.getBaos().flush();
			wadoCtrl.getBaos().close();
		} else {
			response.getWriter().write(wadoCtrl.getResultXml());
		}*/
	}
	
	/**
     * Send an error response with given response code and message to the client.
     * <p>
     * It is recommended that this method is only called once per request!<br>
     * Otherwise a IllegalStateException will be thrown!
     * 
     * @param response	The HttpServletResponse of the request.
     * @param errCode	One of the response code defined in HttpServletResponse.
     * @param msg		A description for the reason to send the error.
     */
    private void sendError( HttpServletResponse response, int errCode, String msg ) {
        try {
            response.sendError( errCode, msg );
        } catch (IOException e) {
            log.error("Cant perform sendError( "+errCode+", "+msg+" )! reason:"+e.getMessage(), e );
        }
    }

    /**
     * Send the retrieved file to the client.
     * <p>
     * Sets the content type as defined in the WADOResponseObject object.
     * 
     * @param response
     * @param respObject
     */
    private void sendWADOFile( HttpServletResponse response, WADOResponseObject respObject ) {
        response.setHeader("Expires","0");//disables client side caching!!!
        log.debug("sendResponse:"+respObject);
        try {
            if ( respObject != null ) {
                log.info("send WADO response: "+respObject.getContentType());
                response.setContentType( respObject.getContentType() );
                long len = respObject.length();
                if ( len != -1 ) 
                    response.setContentLength((int)len);
                final String errMsg = "Exception while writing WADO response to client! reason:";
                try {
                    log.debug("respObject execute");
                    OutputStream respStream = response.getOutputStream();
                    try {
                        respObject.execute(respStream);
                    } finally {
                        respStream.close();
                    }
                }/* catch ( RequestedFrameNumbersOutOfRangeException e ) {
                    sendError(response, HttpServletResponse.SC_BAD_REQUEST,
                    "Error: Requested Frame Numbers Out of Range");
                }*/ catch ( IOException ioe) {
                    if(ioe.toString().startsWith("ClientAbortException:")) {
                        log.debug(errMsg + ioe);
                    } else {
                        log.error(errMsg + ioe.getMessage(), ioe);
                    }
                } catch ( Exception e ) {
                    log.error(errMsg+e.getMessage(), e );
                }

            }
        } catch ( Exception x ) {
            log.error("Exception handling WADO, will send error response", x);
            sendError(	response, HttpServletResponse.SC_INTERNAL_SERVER_ERROR, x.getMessage() );
        }
    }

}
